---
title: Xamarin.Android warning XA4232
description: XA4232 warning code
ms.date: 04/23/2020
---
# Xamarin.Android warning XA4232

## Example messages

```
warning XA4232: The Android code generation target 'XamarinAndroid' is deprecated and will be removed in a future version of Xamarin.Android. Update the project properties to use 'XAJavaInterop1'.
```

## Issue

The Android code generation target `XamarinAndroid` has been deprecated.

## Solution

To resolve this warning, update the **Android Codegen target** setting in the
Visual Studio project property pages or the **Code generation target** setting
in Visual Studio for Mac to **XAJavaInterop1**.  This corresponds to the
`XAJavaInterop1` value for the `AndroidCodegenTarget` MSBuild property in the
_.csproj_ file:

```xml
<PropertyGroup>
  <AndroidCodegenTarget>XAJavaInterop1</AndroidCodegenTarget>
</PropertyGroup>
```